Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time
Class DateTimeUtils

    java.lang.Object
      org.joda.time.DateTimeUtils

    public class DateTimeUtils

extends java.lang.Object

DateTimeUtils provide public utility methods for the datetime library.

DateTimeUtils is thread-safe although shared static variables are used.

Since:
  1.0
Author:
  Stephen Colebourne

Constructor Summary
`protected` | `DateTimeUtils()` Restrictive constructor

Method Summary
`static long` | `currentTimeMillis()` Gets the current time in milliseconds.
`static Chronology` | `getChronology(Chronology chrono)` Gets the chronology handling null.
`static long` | `getDurationMillis(ReadableDuration duration)` Gets the millisecond duration from the specified duration object handling null.
`static Chronology` | `getInstantChronology(ReadableInstant instant)` Gets the chronology from the specified instant object handling null.
`static long` | `getInstantMillis(ReadableInstant instant)` Gets the millisecond instant from the specified instant object handling null.
`static Chronology` | `getIntervalChronology(ReadableInstant start, ReadableInstant end)` Gets the chronology from the specified instant based interval handling null.
`static Chronology` | `getIntervalChronology(ReadableInterval interval)` Gets the chronology from the specified interval object handling null.
`static PeriodType` | `getPeriodType(PeriodType type)` Gets the period type handling null.
`static ReadableInterval` | `getReadableInterval(ReadableInterval interval)` Gets the interval handling null.
`static DateTimeZone` | `getZone(DateTimeZone zone)` Gets the zone handling null.
`static boolean` | `isContiguous(ReadablePartial partial)` Checks whether the partial is contiguous.
`static void` | `setCurrentMillisFixed(long fixedMillis)` Sets the current time to return a fixed millisecond time.
`static void` | `setCurrentMillisOffset(long offsetMillis)` Sets the current time to return the system time plus an offset.
`static void` | `setCurrentMillisSystem()` Resets the current time to return the system time.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DateTimeUtils

    protected DateTimeUtils()

  Restrictive constructor

Method Detail

### currentTimeMillis

    public static final long currentTimeMillis()

  Gets the current time in milliseconds.

  By default this returns `System.currentTimeMillis()`. This may be changed using other methods in this class.

  Returns:
    the current time in milliseconds from 1970-01-01T00:00:00Z

### setCurrentMillisSystem

    public static final void setCurrentMillisSystem()
                                             throws java.lang.SecurityException

  Resets the current time to return the system time.

  This method changes the behaviour of `currentTimeMillis()`. Whenever the current time is queried, `System.currentTimeMillis()` is used.

  Throws:
    `java.lang.SecurityException` - if the application does not have sufficient security rights

### setCurrentMillisFixed

    public static final void setCurrentMillisFixed(long fixedMillis)
                                            throws java.lang.SecurityException

  Sets the current time to return a fixed millisecond time.

  This method changes the behaviour of `currentTimeMillis()`. Whenever the current time is queried, the same millisecond time will be returned.

  Parameters:
    `fixedMillis` - the fixed millisecond time to use
  Throws:
    `java.lang.SecurityException` - if the application does not have sufficient security rights

### setCurrentMillisOffset

    public static final void setCurrentMillisOffset(long offsetMillis)
                                             throws java.lang.SecurityException

  Sets the current time to return the system time plus an offset.

  This method changes the behaviour of `currentTimeMillis()`. Whenever the current time is queried, `System.currentTimeMillis()` is used and then offset by adding the millisecond value specified here.

  Parameters:
    `offsetMillis` - the fixed millisecond time to use
  Throws:
    `java.lang.SecurityException` - if the application does not have sufficient security rights

### getInstantMillis

    public static final long getInstantMillis(ReadableInstant instant)

  Gets the millisecond instant from the specified instant object handling null.

  If the instant object is `null`, the `currentTimeMillis()` will be returned. Otherwise, the millis from the object are returned.

  Parameters:
    `instant` - the instant to examine, null means now
  Returns:
    the time in milliseconds from 1970-01-01T00:00:00Z

### getInstantChronology

    public static final Chronology getInstantChronology(ReadableInstant instant)

  Gets the chronology from the specified instant object handling null.

  If the instant object is `null`, or the instant's chronology is `null`, `ISOChronology.getInstance()` will be returned. Otherwise, the chronology from the object is returned.

  Parameters:
    `instant` - the instant to examine, null means ISO in the default zone
  Returns:
    the chronology, never null

### getIntervalChronology

    public static final Chronology getIntervalChronology(ReadableInstant start,
                                                         ReadableInstant end)

  Gets the chronology from the specified instant based interval handling null.

  The chronology is obtained from the start if that is not null, or from the end if the start is null. The result is additionally checked, and if still null then `ISOChronology.getInstance()` will be returned.

  Parameters:
    `start` - the instant to examine and use as the primary source of the chronology
    `end` - the instant to examine and use as the secondary source of the chronology
  Returns:
    the chronology, never null

### getIntervalChronology

    public static final Chronology getIntervalChronology(ReadableInterval interval)

  Gets the chronology from the specified interval object handling null.

  If the interval object is `null`, or the interval's chronology is `null`, `ISOChronology.getInstance()` will be returned. Otherwise, the chronology from the object is returned.

  Parameters:
    `interval` - the interval to examine, null means ISO in the default zone
  Returns:
    the chronology, never null

### getReadableInterval

    public static final ReadableInterval getReadableInterval(ReadableInterval interval)

  Gets the interval handling null.

  If the interval is `null`, an interval representing now to now in the `ISOChronology` will be returned. Otherwise, the interval specified is returned.

  Parameters:
    `interval` - the interval to use, null means now to now
  Returns:
    the interval, never null
  Since:
    1.1

### getChronology

    public static final Chronology getChronology(Chronology chrono)

  Gets the chronology handling null.

  If the chronology is `null`, `ISOChronology.getInstance()` will be returned. Otherwise, the chronology is returned.

  Parameters:
    `chrono` - the chronology to use, null means ISO in the default zone
  Returns:
    the chronology, never null

### getZone

    public static final DateTimeZone getZone(DateTimeZone zone)

  Gets the zone handling null.

  If the zone is `null`, `DateTimeZone.getDefault()` will be returned. Otherwise, the zone specified is returned.

  Parameters:
    `zone` - the time zone to use, null means the default zone
  Returns:
    the time zone, never null

### getPeriodType

    public static final PeriodType getPeriodType(PeriodType type)

  Gets the period type handling null.

  If the zone is `null`, `PeriodType.standard()` will be returned. Otherwise, the type specified is returned.

  Parameters:
    `type` - the time zone to use, null means the standard type
  Returns:
    the type to use, never null

### getDurationMillis

    public static final long getDurationMillis(ReadableDuration duration)

  Gets the millisecond duration from the specified duration object handling null.

  If the duration object is `null`, zero will be returned. Otherwise, the millis from the object are returned.

  Parameters:
    `duration` - the duration to examine, null means zero
  Returns:
    the duration in milliseconds

### isContiguous

    public static final boolean isContiguous(ReadablePartial partial)

  Checks whether the partial is contiguous.

  A partial is contiguous if one field starts where another ends.

  For example `LocalDate` is contiguous because DayOfMonth has the same range (Month) as the unit of the next field (MonthOfYear), and MonthOfYear has the same range (Year) as the unit of the next field (Year).

  Similarly, `LocalTime` is contiguous, as it consists of MillisOfSecond, SecondOfMinute, MinuteOfHour and HourOfDay (note how the names of each field 'join up').

  However, a Year/HourOfDay partial is not contiguous because the range field Day is not equal to the next field Year. Similarly, a DayOfWeek/DayOfMonth partial is not contiguous because the range Month is not equal to the next field Day.

  Parameters:
    `partial` - the partial to check
  Returns:
    true if the partial is contiguous
  Throws:
    `java.lang.IllegalArgumentException` - if the partial is null
  Since:
    1.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD